Subject: bug#17771: 24.3.91; SIGSEGV in cleanup_vector

From: Dmitry Antipov <[email-masked]>
Date: Tue, 17 Jun 2014 06:09:26 +0400

On 06/17/2014 01:33 AM, Stephen Berman wrote:

>      36.00%    emacs  libfontconfig.so.1.8.0         [.] 0x000000000001f643
>      31.34%    emacs  libc-2.18.so                   [.] __strchr_sse2
>       6.78%    emacs  [kernel.kallsyms]              [k] 0xffffffff8103aef6
>       4.12%    emacs  libz.so.1.2.8                  [.] 0x0000000000007cc6
>       1.15%    emacs  libfontconfig.so.1.8.0         [.] FcCharSetSubtractCount

Please also install fontconfig-debuginfo package to get all libfontconfig.so
samples resolved to function names.

Just for the record, I'm seeing the following:

      6.68%        emacs  libc-2.18.so                [.] _IO_getc
      3.90%        emacs  emacs                       [.] mark_object
      2.73%        emacs  emacs                       [.] decode_coding_iso_2022
      2.46%        emacs  emacs                       [.] exec_byte_code
      1.76%        emacs  libgobject-2.0.so.0.3800.2  [.] g_type_check_instance_is_a
      1.65%        emacs  ld-2.18.so                  [.] do_lookup_x
      1.31%        emacs  libglib-2.0.so.0.3800.2     [.] g_private_get_impl
      1.29%        emacs  libc-2.18.so                [.] __strchr_sse2
      1.29%        emacs  libfontconfig.so.1.8.0      [.] FcCompareFamily
      1.22%        emacs  libc-2.18.so                [.] _int_malloc
      1.20%        emacs  libX11.so.6.3.0             [.] parsestringfile
      1.19%        emacs  emacs                       [.] mark_char_table
      1.18%        emacs  libfontconfig.so.1.8.0      [.] FcStrCaseWalkerNext.part.3
      1.17%        emacs  libfontconfig.so.1.8.0      [.] __popcountdi2
      1.12%        emacs  libglib-2.0.so.0.3800.2     [.] g_mutex_get_impl
      1.02%        emacs  libc-2.18.so                [.] malloc

Probably there is a bottleneck in fontconfig which can't scale from hundreds to
thousands of fonts well enough.

Dmitry